/*
 * Setting the extension base variable.
 */
var ext_holder;
var ext_uses_browser = false;
if (typeof browser !== 'undefined') {
  ext_holder = browser;
  ext_uses_browser = true;
} else {
  ext_holder = chrome;
}

/*
 * Auxiliary methods.
 */
var no_op_function = function () {
};

var err_output = function (data) {
  console.log(data);
};

var check_last_error = function () {
  if (ext_holder.runtime.lastError) {
    console.log(ext_holder.runtime.lastError);
  }
};

/*
 * Listening on the browser-toolbar button clicks.
 */
ext_holder.browserAction.onClicked.addListener((tab) => {
  var analysis_url = ext_holder.runtime.getURL("analysis.html");

  if (ext_uses_browser) {
    ext_holder.tabs.create({url: analysis_url + "#", active: true, index: (tab.index+1)}).then(no_op_function, err_output);
  } else {
    ext_holder.tabs.create({url: analysis_url + "#", active: true, index: (tab.index+1)}, check_last_error);
  }
});

/*
 * Creating menu item.
 */
var context_menu_id_analysis = "image_analysis_menu_id";
ext_holder.contextMenus.create({
  "id": context_menu_id_analysis,
  "title": ext_holder.runtime.getManifest().name,
  "type" : "normal",
  "documentUrlPatterns": ["*://*/*"],
  "contexts": ["image"]
}, check_last_error);

/*
 * Listening on the menu item clicks.
 */
ext_holder.contextMenus.onClicked.addListener((info, tab) => {
  if (info.menuItemId==context_menu_id_analysis) {
    if (info.srcUrl.substring(0, 4)=="http") {
      let is_https = false;
      if (info.srcUrl.substring(0, 5)=="https") {
        is_https = true;
      }
      let use_page_url = false;
      let test_src_url = "http" + (is_https ? "s" : "") + "://www.pinterest.com/offsite/?url=";
      if (info.srcUrl.toLowerCase().substring(0, test_src_url.length) == test_src_url) {
        if (info.frameUrl.match(/^http(s)?\:\/\/.{1,5}\.pinimg\.com\/originals\//i)) {
          use_page_url = true;
        }
      }
      let use_url = (use_page_url ? info.frameUrl : info.srcUrl);
      var analysis_url = ext_holder.runtime.getURL("analysis.html");
      if (ext_uses_browser) {
        ext_holder.tabs.create({url: analysis_url + "#" + use_url, active: true, index: (tab.index+1)}).then(no_op_function, err_output);
      } else {
        ext_holder.tabs.create({url: analysis_url + "#" + use_url, active: true, index: (tab.index+1)}, check_last_error);
      }

    }
  }
});

