
var histogram_equalize_gray = function (can_ori_ctx, can_res_ctx, can_width, can_height) {
  debug_output("histogram_equalize_gray");

  var ori_data = can_ori_ctx.getImageData(0, 0, can_width, can_height);
  var ori_arr = ori_data.data;
  var arr_len = ori_arr.length;

  var res_data = can_res_ctx.getImageData(0, 0, can_width, can_height);
  var res_arr = res_data.data;

  if (arr_len != res_arr.length) {
    return;
  }
  if (arr_len==0) {
    return false;
  }

  var pix_counts = new Array(256);
  var pix_sets = new Array(256);
  for (let idx_ini = 255; idx_ini>=0; idx_ini--) {
    pix_counts[idx_ini] = 0;
    pix_sets[idx_ini] = 0;
  }

  let idx = arr_len - 1;
  while (idx>=0) {
    idx -= 3;
    pix_counts[ori_arr[idx]] += 1;
    idx -= 1;
  }

  const mult_fct = 255.0/(can_width*can_height);
  let curr_top = 0;
  for (let idx_set=0; idx_set<256; idx_set++) {
    let curr_cnt = pix_counts[idx_set];
    pix_sets[idx_set] = Math.round((curr_top + (curr_cnt/2)) * mult_fct);
    curr_top += curr_cnt;
  }

  let idx_res = arr_len - 1;
  while (idx_res>=0) {
    idx_res -= 3;
    let res_value = pix_sets[ori_arr[idx_res]];
    res_arr[idx_res+2] = res_value;
    res_arr[idx_res+1] = res_value;
    res_arr[idx_res] = res_value;
    idx_res -= 1;
  }

  can_res_ctx.putImageData(res_data, 0, 0);
};

var histogram_equalize_colors = function (can_ori_ctx, can_res_ctx, can_width, can_height) {
  debug_output("histogram_equalize_colors");

  var ori_data = can_ori_ctx.getImageData(0, 0, can_width, can_height);
  var ori_arr = ori_data.data;
  var arr_len = ori_arr.length;

  var res_data = can_res_ctx.getImageData(0, 0, can_width, can_height);
  var res_arr = res_data.data;

  if (arr_len != res_arr.length) {
    return;
  }
  if (arr_len==0) {
    return false;
  }

  var pix_counts_r = new Array(256);
  var pix_counts_g = new Array(256);
  var pix_counts_b = new Array(256);
  var pix_sets_r = new Array(256);
  var pix_sets_g = new Array(256);
  var pix_sets_b = new Array(256);
  for (let idx_ini = 255; idx_ini>=0; idx_ini--) {
    pix_counts_r[idx_ini] = 0;
    pix_counts_g[idx_ini] = 0;
    pix_counts_b[idx_ini] = 0;
    pix_sets_r[idx_ini] = 0;
    pix_sets_g[idx_ini] = 0;
    pix_sets_b[idx_ini] = 0;
  }

  let idx = arr_len - 1;
  while (idx>=0) {
    idx -= 1;
    pix_counts_b[ori_arr[idx]] += 1;
    idx -= 1;
    pix_counts_g[ori_arr[idx]] += 1;
    idx -= 1;
    pix_counts_r[ori_arr[idx]] += 1;
    idx -= 1;
  }

  const mult_fct = 255.0/(can_width*can_height);
  let curr_top_r = 0;
  for (let idx_set=0; idx_set<256; idx_set++) {
    let curr_cnt_r = pix_counts_r[idx_set];
    pix_sets_r[idx_set] = Math.round((curr_top_r + (curr_cnt_r/2)) * mult_fct);
    curr_top_r += curr_cnt_r;
  }
  let curr_top_g = 0;
  for (let idx_set=0; idx_set<256; idx_set++) {
    let curr_cnt_g = pix_counts_g[idx_set];
    pix_sets_g[idx_set] = Math.round((curr_top_g + (curr_cnt_g/2)) * mult_fct);
    curr_top_g += curr_cnt_g;
  }
  let curr_top_b = 0;
  for (let idx_set=0; idx_set<256; idx_set++) {
    let curr_cnt_b = pix_counts_b[idx_set];
    pix_sets_b[idx_set] = Math.round((curr_top_b + (curr_cnt_b/2)) * mult_fct);
    curr_top_b += curr_cnt_b;
  }

  let idx_res = arr_len - 1;
  while (idx_res>=0) {
    res_arr[idx_res] = 255;
    idx_res -= 1;
    res_arr[idx_res] = pix_sets_b[ori_arr[idx_res]];
    idx_res -= 1;
    res_arr[idx_res] = pix_sets_g[ori_arr[idx_res]];
    idx_res -= 1;
    res_arr[idx_res] = pix_sets_r[ori_arr[idx_res]];
    idx_res -= 1;
  }

  can_res_ctx.putImageData(res_data, 0, 0);

};

