////////////////////////////////////////////////////////////////////////
// slopes-wise methods

var slopes_highlight_any_single = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_any_single");

  const col_count_use = col_count;
  const row_count_use = row_count;

  const step_row = 4*col_count_use;

  for (let row = row_count_use-2; row > 0; row--) {
    for (let col = col_count_use-2; col > 0; col--) {
      let idx = (row*col_count_use + col) * 4;
      for (let ins = 0; ins < 3; ins++, idx++) {
        let ori_val = ori_arr[idx];
        res_arr[idx] = Math.abs(ori_arr[idx - 4] - ori_val) + Math.abs(ori_arr[idx + 4] - ori_val) + Math.abs(ori_arr[idx - step_row] - ori_val) + Math.abs(ori_arr[idx + step_row] - ori_val);
      }
      res_arr[idx] = 255;
    }
  }
};

var slopes_highlight_any_lumi = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_any_lumi");

  const col_count_use = col_count;
  const row_count_use = row_count;

  const step_row = 4*col_count_use;
  const step_row_m1 = 4*col_count_use - 1;
  const step_row_m2 = 4*col_count_use - 2;
  const step_row_g1 = 4*col_count_use + 1;
  const step_row_g2 = 4*col_count_use + 2;

  for (let row = row_count_use-2; row > 0; row--) {
    for (let col = col_count_use-2; col > 0; col--) {
      let idx = (row*col_count_use + col) * 4;
      let ori_val = ori_arr[idx] + ori_arr[idx+1] + ori_arr[idx+2];
      res_arr[idx] = Math.abs(ori_arr[idx - 4] + ori_arr[idx - 3] + ori_arr[idx - 2] - ori_val) + Math.abs(ori_arr[idx + 4] + ori_arr[idx + 5] + ori_arr[idx + 6] - ori_val);
      res_arr[idx+1] = Math.abs(ori_arr[idx - step_row] + ori_arr[idx - step_row_m1] + ori_arr[idx - step_row_m2] - ori_val) + Math.abs(ori_arr[idx + step_row] + ori_arr[idx - step_row_g1] + ori_arr[idx - step_row_g2] - ori_val);
      res_arr[idx+2] = 0;
      res_arr[idx+3] = 255;
    }
  }
};

var slopes_highlight_any_double = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_any_double");

  const col_count_use = col_count;
  const row_count_use = row_count;

  const step_row = 8*col_count_use;

  for (let row = row_count_use-3; row > 1; row--) {
    for (let col = col_count_use-3; col > 1; col--) {
      let idx = (row*col_count_use + col) * 4;
      for (let ins = 0; ins < 3; ins++, idx++) {
        let ori_val = ori_arr[idx];
        res_arr[idx] = Math.abs(ori_arr[idx - 8] - ori_val) + Math.abs(ori_arr[idx + 8] - ori_val) + Math.abs(ori_arr[idx - step_row] - ori_val) + Math.abs(ori_arr[idx + step_row] - ori_val);
      }
      res_arr[idx] = 255;
    }
  }
};

var slopes_highlight_any_double_lumi = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_any_double_lumi");

  const col_count_use = col_count;
  const row_count_use = row_count;

  const step_row = 8*col_count_use;
  const step_row_m1 = 8*col_count_use - 1;
  const step_row_m2 = 8*col_count_use - 2;
  const step_row_g1 = 8*col_count_use + 1;
  const step_row_g2 = 8*col_count_use + 2;

  for (let row = row_count_use-3; row > 1; row--) {
    for (let col = col_count_use-3; col > 1; col--) {
      let idx = (row*col_count_use + col) * 4;
      let ori_val = ori_arr[idx] + ori_arr[idx+1] + ori_arr[idx+2];
      res_arr[idx] = Math.abs(ori_arr[idx - 8] + ori_arr[idx - 7] + ori_arr[idx - 6] - ori_val) + Math.abs(ori_arr[idx + 8] + ori_arr[idx + 9] + ori_arr[idx + 10] - ori_val);
      res_arr[idx+1] = Math.abs(ori_arr[idx - step_row] + ori_arr[idx - step_row_m1] + ori_arr[idx - step_row_m2] - ori_val) + Math.abs(ori_arr[idx + step_row] + ori_arr[idx - step_row_g1] + ori_arr[idx - step_row_g2] - ori_val);
      res_arr[idx+2] = 0;
      res_arr[idx+3] = 255;
    }
  }
};

var slopes_highlight_steady_single = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_steady_single");

  const col_count_use = col_count;
  const row_count_use = row_count;

  const step_row = 4*col_count_use;

  for (let row = row_count_use-2; row > 0; row--) {
    for (let col = col_count_use-2; col > 0; col--) {
      let idx = (row*col_count_use + col) * 4;
      for (let ins = 0; ins < 3; ins++, idx++) {
        res_arr[idx] = Math.abs(ori_arr[idx - 4] - ori_arr[idx + 4]) + Math.abs(ori_arr[idx - step_row] - ori_arr[idx + step_row]);
      }
      res_arr[idx] = 255;
    }
  }
};

var slopes_highlight_steady_lumi = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_steady_lumi");

  const col_count_use = col_count;
  const row_count_use = row_count;

  const step_row = 4*col_count_use;
  const step_row_m1 = 4*col_count_use - 1;
  const step_row_m2 = 4*col_count_use - 2;
  const step_row_g1 = 4*col_count_use + 1;
  const step_row_g2 = 4*col_count_use + 2;

  for (let row = row_count_use-2; row > 0; row--) {
    for (let col = col_count_use-2; col > 0; col--) {
      let idx = (row*col_count_use + col) * 4;
      res_arr[idx] = Math.abs((ori_arr[idx - 4] + ori_arr[idx - 3] + ori_arr[idx - 2]) - (ori_arr[idx + 4] + ori_arr[idx + 5] + ori_arr[idx + 6]));
      res_arr[idx+1] = Math.abs((ori_arr[idx - step_row] + ori_arr[idx - step_row_m1] + ori_arr[idx - step_row_m2]) - (ori_arr[idx + step_row] + ori_arr[idx - step_row_g1] + ori_arr[idx - step_row_g2]));
      res_arr[idx+2] = 0;
      res_arr[idx+3] = 255;
    }
  }
};

var slopes_highlight_steady_double = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_steady_double");

  const col_count_use = col_count;
  const row_count_use = row_count;

  const step_row = 8*col_count_use;

  for (let row = row_count_use-3; row > 1; row--) {
    for (let col = col_count_use-3; col > 1; col--) {
      let idx = (row*col_count_use + col) * 4;
      for (let ins = 0; ins < 3; ins++, idx++) {
        res_arr[idx] = Math.abs(ori_arr[idx - 8] - ori_arr[idx + 8]) + Math.abs(ori_arr[idx - step_row] - ori_arr[idx + step_row]);
      }
      res_arr[idx] = 255;
    }
  }
};

var slopes_highlight_steady_double_lumi = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_steady_double_lumi");

  const col_count_use = col_count;
  const row_count_use = row_count;

  const step_row = 8*col_count_use;
  const step_row_m1 = 8*col_count_use - 1;
  const step_row_m2 = 8*col_count_use - 2;
  const step_row_g1 = 8*col_count_use + 1;
  const step_row_g2 = 8*col_count_use + 2;

  for (let row = row_count_use-3; row > 1; row--) {
    for (let col = col_count_use-3; col > 1; col--) {
      let idx = (row*col_count_use + col) * 4;
      res_arr[idx] = Math.abs((ori_arr[idx - 8] + ori_arr[idx - 7] + ori_arr[idx - 6]) - (ori_arr[idx + 8] + ori_arr[idx + 9] + ori_arr[idx + 10]));
      res_arr[idx+1] = Math.abs((ori_arr[idx - step_row] + ori_arr[idx - step_row_m1] + ori_arr[idx - step_row_m2]) - (ori_arr[idx + step_row] + ori_arr[idx - step_row_g1] + ori_arr[idx - step_row_g2]));
      res_arr[idx+2] = 0;
      res_arr[idx+3] = 255;
    }
  }
};

var slopes_highlight_grainy_single = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_grainy_single");

  const col_count_use = col_count;
  const row_count_use = row_count;

  const step_row = 4*col_count_use;

  for (let row = row_count_use-2; row > 0; row--) {
    for (let col = col_count_use-2; col > 0; col--) {
      let idx = (row*col_count_use + col) * 4;
      for (let ins = 0; ins < 3; ins++, idx++) {
        let ori_val = 2*ori_arr[idx];
        res_arr[idx] = Math.abs(ori_arr[idx - 4] + ori_arr[idx + 4] - ori_val) + Math.abs(ori_arr[idx - step_row] + ori_arr[idx + step_row] - ori_val);
      }
      res_arr[idx] = 255;
    }
  }
};

var slopes_highlight_grainy_lumi = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_grainy_lumi");

  const col_count_use = col_count;
  const row_count_use = row_count;

  const step_row = 4*col_count_use;
  const step_row_m1 = 4*col_count_use - 1;
  const step_row_m2 = 4*col_count_use - 2;
  const step_row_g1 = 4*col_count_use + 1;
  const step_row_g2 = 4*col_count_use + 2;

  for (let row = row_count_use-2; row > 0; row--) {
    for (let col = col_count_use-2; col > 0; col--) {
      let idx = (row*col_count_use + col) * 4;
      let ori_val = 6*ori_arr[idx];
      res_arr[idx] = Math.abs((ori_arr[idx - 4] + ori_arr[idx - 3] + ori_arr[idx - 2]) + (ori_arr[idx + 4] + ori_arr[idx + 5] + ori_arr[idx + 6]) - ori_val);
      res_arr[idx+1] = Math.abs((ori_arr[idx - step_row] + ori_arr[idx - step_row_m1] + ori_arr[idx - step_row_m2]) + (ori_arr[idx + step_row] + ori_arr[idx - step_row_g1] + ori_arr[idx - step_row_g2]) - ori_val);
      res_arr[idx+2] = 0;
      res_arr[idx+3] = 255;
    }
  }
};

var slopes_highlight_grainy_double = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_grainy_double");

  const col_count_use = col_count;
  const row_count_use = row_count;

  const step_row = 8*col_count_use;

  for (let row = row_count_use-3; row > 1; row--) {
    for (let col = col_count_use-3; col > 1; col--) {
      let idx = (row*col_count_use + col) * 4;
      for (let ins = 0; ins < 3; ins++, idx++) {
        let ori_val = 2*ori_arr[idx];
        res_arr[idx] = Math.abs(ori_arr[idx - 8] + ori_arr[idx + 8] - ori_val) + Math.abs(ori_arr[idx - step_row] + ori_arr[idx + step_row] - ori_val);
      }
      res_arr[idx] = 255;
    }
  }
};

var slopes_highlight_grainy_double_lumi = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_grainy_double_lumi");

  const col_count_use = col_count;
  const row_count_use = row_count;

  const step_row = 8*col_count_use;
  const step_row_m1 = 8*col_count_use - 1;
  const step_row_m2 = 8*col_count_use - 2;
  const step_row_g1 = 8*col_count_use + 1;
  const step_row_g2 = 8*col_count_use + 2;

  for (let row = row_count_use-3; row > 1; row--) {
    for (let col = col_count_use-3; col > 1; col--) {
      let idx = (row*col_count_use + col) * 4;
      let ori_val = 6*ori_arr[idx];
      res_arr[idx] = Math.abs((ori_arr[idx - 8] + ori_arr[idx - 7] + ori_arr[idx - 6]) + (ori_arr[idx + 8] + ori_arr[idx + 9] + ori_arr[idx + 10]) - ori_val);
      res_arr[idx+1] = Math.abs((ori_arr[idx - step_row] + ori_arr[idx - step_row_m1] + ori_arr[idx - step_row_m2]) + (ori_arr[idx + step_row] + ori_arr[idx - step_row_g1] + ori_arr[idx - step_row_g2]) - ori_val);
      res_arr[idx+2] = 0;
      res_arr[idx+3] = 255;
    }
  }

};

var slopes_highlight_blur_single_pre = function (can_ori_el, can_res_ctx) {
  can_res_ctx.globalCompositeOperation = "copy";
  can_res_ctx.filter = "blur(1px)";
  can_res_ctx.drawImage(can_ori_el, 0, 0);
  can_res_ctx.filter = "";
};

var slopes_highlight_blur_double_pre = function (can_ori_el, can_res_ctx) {
  can_res_ctx.globalCompositeOperation = "copy";
  can_res_ctx.filter = "blur(2px)";
  can_res_ctx.drawImage(can_ori_el, 0, 0);
  can_res_ctx.filter = "";
};

var slopes_highlight_blur = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_blur");
    
  let idx = (4 * col_count * row_count) - 1;
  while (idx >= 0) {
    res_arr[idx] = 255;
    idx -= 1;
    res_arr[idx] = Math.abs(ori_arr[idx]-res_arr[idx]);
    idx -= 1;
    res_arr[idx] = Math.abs(ori_arr[idx]-res_arr[idx]);
    idx -= 1;
    res_arr[idx] = Math.abs(ori_arr[idx]-res_arr[idx]);
    idx -= 1;
  }
};

var slopes_highlight_blur_lumi = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_highlight_blur_lumi");
    
  let idx = (4 * col_count * row_count) - 1;
  while (idx >= 0) {
    res_arr[idx] = 255;
    idx -= 1;
    let diff_val = Math.abs(ori_arr[idx]-res_arr[idx]);
    idx -= 1;
    diff_val += Math.abs(ori_arr[idx]-res_arr[idx]);
    idx -= 1;
    diff_val += Math.abs(ori_arr[idx]-res_arr[idx]);
    res_arr[idx+2] = diff_val;
    res_arr[idx+1] = diff_val;
    res_arr[idx] = diff_val;
    idx -= 1;
  }
};

var slopes_black_border_single = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_black_border_single");

  const col_count_use = col_count;
  const row_count_use = row_count;

  for (let row = row_count-1; row >= 0; row--) {
    let idx1 = (row*col_count_use) * 4;
    res_arr[idx1] = 0;
    res_arr[idx1+1] = 0;
    res_arr[idx1+2] = 0;
    res_arr[idx1+3] = 255;
    let idx2 = (row*col_count_use + (col_count_use-1)) * 4;
    res_arr[idx2] = 0;
    res_arr[idx2+1] = 0;
    res_arr[idx2+2] = 0;
    res_arr[idx2+3] = 255;
  }

  for (let col = col_count-2; col >= 1; col--) {
    let idx1 = col * 4;
    res_arr[idx1] = 0;
    res_arr[idx1+1] = 0;
    res_arr[idx1+2] = 0;
    res_arr[idx1+3] = 255;
    let idx2 = ((row_count_use-1)*col_count_use + col) * 4;
    res_arr[idx2] = 0;
    res_arr[idx2+1] = 0;
    res_arr[idx2+2] = 0;
    res_arr[idx2+3] = 255;
  }

};

var slopes_black_border_double = function (ori_arr, res_arr, col_count, row_count) {
  debug_output("slopes_black_border_double");

  const col_count_use = col_count;
  const row_count_use = row_count;

  for (let row = row_count-1; row >= 0; row--) {
    let idx1 = (row*col_count_use) * 4;
    res_arr[idx1] = 0;
    res_arr[idx1+1] = 0;
    res_arr[idx1+2] = 0;
    res_arr[idx1+3] = 255;
    res_arr[idx1+4] = 0;
    res_arr[idx1+5] = 0;
    res_arr[idx1+6] = 0;
    res_arr[idx1+7] = 255;
    let idx2 = (row*col_count_use + (col_count_use-1)) * 4;
    res_arr[idx2-4] = 0;
    res_arr[idx2-3] = 0;
    res_arr[idx2-2] = 0;
    res_arr[idx2-1] = 255;
    res_arr[idx2] = 0;
    res_arr[idx2+1] = 0;
    res_arr[idx2+2] = 0;
    res_arr[idx2+3] = 255;
  }

  for (let col = col_count-3; col >= 2; col--) {
    let idx1 = col * 4;
    res_arr[idx1] = 0;
    res_arr[idx1+1] = 0;
    res_arr[idx1+2] = 0;
    res_arr[idx1+3] = 255;
    let idx2 = (col_count_use + col) * 4;
    res_arr[idx2] = 0;
    res_arr[idx2+1] = 0;
    res_arr[idx2+2] = 0;
    res_arr[idx2+3] = 255;
    let idx3 = ((row_count_use-2)*col_count_use + col) * 4;
    res_arr[idx3] = 0;
    res_arr[idx3+1] = 0;
    res_arr[idx3+2] = 0;
    res_arr[idx3+3] = 255;
    let idx4 = ((row_count_use-1)*col_count_use + col) * 4;
    res_arr[idx4] = 0;
    res_arr[idx4+1] = 0;
    res_arr[idx4+2] = 0;
    res_arr[idx4+3] = 255;
  }

};

var slopes_highlight = function (can_ori_el, can_ori_ctx, can_res_ctx, can_width, can_height, form_slopes, lumin_slopes, step_slopes) {
  debug_output("slopes_highlight");

  if (form_slopes=="blur") {
    if (step_slopes == 2) {
      slopes_highlight_blur_double_pre(can_ori_el, can_res_ctx);
    } else {
      slopes_highlight_blur_single_pre(can_ori_el, can_res_ctx);
    }
  }

  var ori_data = can_ori_ctx.getImageData(0, 0, can_width, can_height);
  var ori_arr = ori_data.data;
  var arr_len = ori_arr.length;

  var res_data = can_res_ctx.getImageData(0, 0, can_width, can_height);
  var res_arr = res_data.data;

  if (arr_len != res_arr.length) {
    return;
  }
  if (arr_len==0) {
    return;
  }

  switch (form_slopes) {
    case "blur":
      if (lumin_slopes) {
        slopes_highlight_blur_lumi(ori_arr, res_arr, can_width, can_height);
      } else {
        slopes_highlight_blur(ori_arr, res_arr, can_width, can_height);
      }
      break;
    case "grainy":
      if (step_slopes == 2) {
        if (lumin_slopes) {
          slopes_highlight_grainy_double_lumi(ori_arr, res_arr, can_width, can_height);
        } else {
          slopes_highlight_grainy_double(ori_arr, res_arr, can_width, can_height);
        }
      } else {
        if (lumin_slopes) {
          slopes_highlight_grainy_lumi(ori_arr, res_arr, can_width, can_height);
        } else {
          slopes_highlight_grainy_single(ori_arr, res_arr, can_width, can_height);
        }
      }
      break;
    case "steady":
      if (step_slopes == 2) {
        if (lumin_slopes) {
          slopes_highlight_steady_double_lumi(ori_arr, res_arr, can_width, can_height);
        } else {
          slopes_highlight_steady_double(ori_arr, res_arr, can_width, can_height);
        }
      } else {
        if (lumin_slopes) {
          slopes_highlight_steady_lumi(ori_arr, res_arr, can_width, can_height);
        } else {
          slopes_highlight_steady_single(ori_arr, res_arr, can_width, can_height);
        }
      }
      break;
    default:
      if (step_slopes == 2) {
        if (lumin_slopes) {
          slopes_highlight_any_double_lumi(ori_arr, res_arr, can_width, can_height);
        } else {
          slopes_highlight_any_double(ori_arr, res_arr, can_width, can_height);
        }
      } else {
        if (lumin_slopes) {
          slopes_highlight_any_lumi(ori_arr, res_arr, can_width, can_height);
        } else {
          slopes_highlight_any_single(ori_arr, res_arr, can_width, can_height);
        }
      }
  }

  if (form_slopes != "blur") {
    if (step_slopes == 2) {
      slopes_black_border_double(ori_arr, res_arr, can_width, can_height);
    } else {
      slopes_black_border_single(ori_arr, res_arr, can_width, can_height);
    }
  }

  can_res_ctx.putImageData(res_data, 0, 0);
  return;
};

