////////////////////////////////////////////////////////////////////////
// auxiliary stuff

var blink_load_button = function () {
  debug_output("blink_load_button");

  let blink_class = "ctrl-load-input-notice";
  let bt_file_el = document.getElementById("file-parts");
  if (bt_file_el) {
    if (bt_file_el.classList.contains(blink_class)) {
      bt_file_el.classList.remove(blink_class);
    }
    setTimeout(function () {
      bt_file_el.classList.add(blink_class);
    }, 10);
  }
};

////////////////////////////////////////////////////////////////////////
// using the about part

var make_current_about = function (force) {
  debug_output("make_current_about: " + disp_part_about);

  let view_forensics_el = document.getElementById("field-about-forensics-holder");
  let bt_forensics_off_el = document.getElementById("bt-about-forensics-off");
  let bt_forensics_on_el = document.getElementById("bt-about-forensics-on");

  let view_meta_el = document.getElementById("field-about-meta-holder");
  let bt_meta_off_el = document.getElementById("bt-about-meta-off");
  let bt_meta_on_el = document.getElementById("bt-about-meta-on");

  let view_levels_el = document.getElementById("field-about-levels-holder");
  let bt_levels_off_el = document.getElementById("bt-about-levels-off");
  let bt_levels_on_el = document.getElementById("bt-about-levels-on");

  let view_slopes_el = document.getElementById("field-about-slopes-holder");
  let bt_slopes_off_el = document.getElementById("bt-about-slopes-off");
  let bt_slopes_on_el = document.getElementById("bt-about-slopes-on");

  let view_ela_el = document.getElementById("field-about-ela-holder");
  let bt_ela_off_el = document.getElementById("bt-about-ela-off");
  let bt_ela_on_el = document.getElementById("bt-about-ela-on");

  let view_pca_el = document.getElementById("field-about-pca-holder");
  let bt_pca_off_el = document.getElementById("bt-about-pca-off");
  let bt_pca_on_el = document.getElementById("bt-about-pca-on");

  let view_image_el = document.getElementById("field-about-image-holder");
  let bt_image_off_el = document.getElementById("bt-about-image-off");
  let bt_image_on_el = document.getElementById("bt-about-image-on");

  let show_forensics = false;
  let show_meta = false;
  let show_levels = false;
  let show_slopes = false;
  let show_ela = false;
  let show_pca = false;
  let show_image = false;

  switch (disp_part_about) {
    case "forensics":
      show_forensics = true;
      break;
    case "meta":
      show_meta = true;
      break;
    case "levels":
      show_levels = true;
      break;
    case "slopes":
      show_slopes = true;
      break;
    case "ela":
      show_ela = true;
      break;
    case "pca":
      show_pca = true;
      break;
    case "image":
      show_image = true;
      break;
    default:
      break;
  }

  let set_els = [
    [view_forensics_el, show_forensics],
    [bt_forensics_off_el, (!show_forensics)],
    [bt_forensics_on_el, show_forensics],
    [view_meta_el, show_meta],
    [bt_meta_off_el, (!show_meta)],
    [bt_meta_on_el, show_meta],
    [view_levels_el, show_levels],
    [bt_levels_off_el, (!show_levels)],
    [bt_levels_on_el, show_levels],
    [view_slopes_el, show_slopes],
    [bt_slopes_off_el, (!show_slopes)],
    [bt_slopes_on_el, show_slopes],
    [view_ela_el, show_ela],
    [bt_ela_off_el, (!show_ela)],
    [bt_ela_on_el, show_ela],
    [view_pca_el, show_pca],
    [bt_pca_off_el, (!show_pca)],
    [bt_pca_on_el, show_pca],
    [view_image_el, show_image],
    [bt_image_off_el, (!show_image)],
    [bt_image_on_el, show_image]
  ];

  for (let one_el_idx = set_els.length-1; one_el_idx >= 0; one_el_idx--) {
    let one_el_info = set_els[one_el_idx];
    let one_el = one_el_info[0];
    let one_el_show = one_el_info[1];
    if (one_el) {
      if (one_el_show) {
        if (one_el.classList.contains(class_el_hidden)) {
          one_el.classList.remove(class_el_hidden);
        }
      } else {
        if (!(one_el.classList.contains(class_el_hidden))) {
          one_el.classList.add(class_el_hidden);
        }
      }
    }
  }

};

////////////////////////////////////////////////////////////////////////
// using the meta part

var make_current_meta = function (force) {
  debug_output("make_current_meta: " + disp_part_meta);

  if ((disp_part_meta=="exif") && (!image_has_exif)) {
    disp_part_meta = "thumb";
  }
  if ((disp_part_meta=="thumb") && (!image_has_thumb)) {
    disp_part_meta = "file";
  }

  let view_exif_el = document.getElementById("field-meta-exif-holder");
  let bt_exif_off_el = document.getElementById("bt-meta-exif-off");
  let bt_exif_on_el = document.getElementById("bt-meta-exif-on");

  let view_thumb_el = document.getElementById("field-meta-thumb-holder");
  let bt_thumb_off_el = document.getElementById("bt-meta-thumb-off");
  let bt_thumb_on_el = document.getElementById("bt-meta-thumb-on");

  let view_file_el = document.getElementById("field-meta-file-holder");
  let bt_file_off_el = document.getElementById("bt-meta-file-off");
  let bt_file_on_el = document.getElementById("bt-meta-file-on");

  let show_exif = false;
  let show_thumb = false;
  let show_file = false;

  switch (disp_part_meta) {
    case "exif":
      show_exif = true;
      break;
    case "thumb":
      show_thumb = true;
      break;
    case "file":
      show_file = true;
      break;
    default:
      break;
  }

  let set_els = [
    [view_exif_el, show_exif],
    [bt_exif_off_el, (!show_exif)],
    [bt_exif_on_el, show_exif],
    [view_thumb_el, show_thumb],
    [bt_thumb_off_el, (!show_thumb)],
    [bt_thumb_on_el, show_thumb],
    [view_file_el, show_file],
    [bt_file_off_el, (!show_file)],
    [bt_file_on_el, show_file]
  ];

  for (let one_el_idx = set_els.length-1; one_el_idx >= 0; one_el_idx--) {
    let one_el_info = set_els[one_el_idx];
    let one_el = one_el_info[0];
    let one_el_show = one_el_info[1];
    if (one_el) {
      if (one_el_show) {
        if (one_el.classList.contains(class_el_hidden)) {
          one_el.classList.remove(class_el_hidden);
        }
      } else {
        if (!(one_el.classList.contains(class_el_hidden))) {
          one_el.classList.add(class_el_hidden);
        }
      }
    }
  }

};

////////////////////////////////////////////////////////////////////////
// using the levels part

var clean_levels_values = function () {
  last_spread_levels_val = "";
};

var set_levels_display_center = function () {
  debug_output("set_levels_display_center");

  var cent_val_el = document.getElementById("label-levels-center-value");
  if (cent_val_el) {
    let center_str = "" + center_levels_val;
    if (center_str.length == 3) {
      center_str += "0";
    }
    cent_val_el.innerHTML = center_str;
  }
};

var set_levels_display_contrast = function () {
  debug_output("set_levels_display_contrast");

  var width_val_el = document.getElementById("label-levels-contrast-value");
  if (width_val_el) {
    let cont_str  = "" + (1 + (contrast_levels_val/10));
    if (cont_str.length == 1) {
      cont_str += ".0";
    }
    width_val_el.innerHTML = cont_str;
  }
};

var set_levels_knobs_center = function () {
  debug_output("set_levels_knobs_center");

  var levels_cent_el = document.getElementById("rn-levels-center");
  if (levels_cent_el) {
    levels_cent_el.value = center_levels_val;
  }
};

var set_levels_knobs_contrast = function () {
  debug_output("set_levels_knobs_contrast");

  var levels_contrast_el = document.getElementById("rn-levels-contrast");
  if (levels_contrast_el) {
    levels_contrast_el.value = contrast_levels_val;
  }
};

var set_levels_knobs = function () {
  debug_output("set_levels_knobs");

  let bt_gray_off_el = document.getElementById("bt-levels-alt-gray-off");
  let bt_gray_on_el = document.getElementById("bt-levels-alt-gray-on");

  let bt_spread_off_el = document.getElementById("bt-levels-alt-spread-off");
  let bt_spread_on_el = document.getElementById("bt-levels-alt-spread-on");

  if (bt_gray_off_el) {
    if (gray_levels_val) {
      if (!(bt_gray_off_el.classList.contains(class_el_hidden))) {
        bt_gray_off_el.classList.add(class_el_hidden);
      }
    } else {
      if (bt_gray_off_el.classList.contains(class_el_hidden)) {
        bt_gray_off_el.classList.remove(class_el_hidden);
      }
    }
  }
  if (bt_gray_on_el) {
    if (gray_levels_val) {
      if (bt_gray_on_el.classList.contains(class_el_hidden)) {
        bt_gray_on_el.classList.remove(class_el_hidden);
      }
    } else {
      if (!(bt_gray_on_el.classList.contains(class_el_hidden))) {
        bt_gray_on_el.classList.add(class_el_hidden);
      }
    }
  }

  if (bt_spread_off_el) {
    if (spread_levels_val) {
      if (!(bt_spread_off_el.classList.contains(class_el_hidden))) {
        bt_spread_off_el.classList.add(class_el_hidden);
      }
    } else {
      if (bt_spread_off_el.classList.contains(class_el_hidden)) {
        bt_spread_off_el.classList.remove(class_el_hidden);
      }
    }
  }
  if (bt_spread_on_el) {
    if (spread_levels_val) {
      if (bt_spread_on_el.classList.contains(class_el_hidden)) {
        bt_spread_on_el.classList.remove(class_el_hidden);
      }
    } else {
      if (!(bt_spread_on_el.classList.contains(class_el_hidden))) {
        bt_spread_on_el.classList.add(class_el_hidden);
      }
    }
  }
};

var switch_levels_gray_outer = function (evt) {
  debug_output("switch_levels_gray_outer");

  evt = evt || window.event;
  if (typeof evt !== "undefined") {
    if (evt.preventDefault) {evt.preventDefault();}
    if (evt.stopPropagation) {evt.stopPropagation();}
  }

  switch_levels_gray();
};

var switch_levels_gray = function () {
  debug_output("switch_levels_gray");

  gray_levels_val = !gray_levels_val;

  set_levels_knobs();
  update_filters();
};

var switch_levels_spread_outer = function (evt) {
  debug_output("switch_levels_spread_outer");

  evt = evt || window.event;
  if (typeof evt !== "undefined") {
    if (evt.preventDefault) {evt.preventDefault();}
    if (evt.stopPropagation) {evt.stopPropagation();}
  }

  switch_levels_spread();
};

var switch_levels_spread = function () {
  debug_output("switch_levels_spread");

  spread_levels_val = !spread_levels_val;

  set_levels_knobs();
  update_filters();
  make_current_levels(true);
};

var make_current_levels = function (force) {
  debug_output("make_current_levels");

  if ((!can_ori_ctx) || (!can_res_levels_ctx)) {
    return;
  }

  let to_eval = force;
  if (last_spread_levels_val !== spread_levels_val) {
    to_eval = true;
  }

  if (to_eval) {
    if (spread_levels_val) {
      histogram_equalize_colors(can_ori_ctx, can_res_levels_ctx, can_width, can_height);
    } else {
      can_res_levels_ctx.drawImage(can_ori_el, 0, 0);
    }
    last_spread_levels_val = spread_levels_val;
  }

  if (img_scaled) {
    update_scaled_view();
  }

};

////////////////////////////////////////////////////////////////////////
// using the slopes part

var clean_slopes_values = function () {
  debug_output("clean_slopes_values");

  last_slopes_step = "";
  last_slopes_lumin = "";
  last_slopes_form = "";
};

var set_slopes_display_light = function () {
  debug_output("set_slopes_display_light");

  let slopes_light_val_el = document.getElementById("label-slopes-light-value");

  if (slopes_light_val_el) {
    slopes_light_val_el.innerHTML = light_slopes;
  }
};

var set_slopes_knobs_light = function () {
  debug_output("set_slopes_knobs_light");

  if (slopes_light_el) {
    slopes_light_el.value = light_slopes;
  }
};

var set_slopes_knobs = function () {
  debug_output("set_slopes_knobs");

  let bt_form_any_off_el = document.getElementById("bt-slopes-form-any-off");
  let bt_form_any_on_el = document.getElementById("bt-slopes-form-any-on");

  let bt_form_steady_off_el = document.getElementById("bt-slopes-form-steady-off");
  let bt_form_steady_on_el = document.getElementById("bt-slopes-form-steady-on");

  let bt_form_grainy_off_el = document.getElementById("bt-slopes-form-grainy-off");
  let bt_form_grainy_on_el = document.getElementById("bt-slopes-form-grainy-on");

  let bt_form_blur_off_el = document.getElementById("bt-slopes-form-blur-off");
  let bt_form_blur_on_el = document.getElementById("bt-slopes-form-blur-on");

  let bt_modif_lumin_off_el = document.getElementById("bt-slopes-modif-lumin-off");
  let bt_modif_lumin_on_el = document.getElementById("bt-slopes-modif-lumin-on");

  let bt_step_double_off_el = document.getElementById("bt-slopes-modif-double-off");
  let bt_step_double_on_el = document.getElementById("bt-slopes-modif-double-on");

  let is_form_any = (form_slopes == "any");
  let is_form_steady = (form_slopes == "steady");
  let is_form_grainy = (form_slopes == "grainy");
  let is_form_blur = (form_slopes == "blur");
  let is_step_lumin = lumin_slopes;
  let is_step_double = (step_slopes == 2);

  let set_els = [
    [bt_form_any_off_el, (!is_form_any)],
    [bt_form_any_on_el, is_form_any],
    [bt_form_steady_off_el, (!is_form_steady)],
    [bt_form_steady_on_el, is_form_steady],
    [bt_form_grainy_off_el, (!is_form_grainy)],
    [bt_form_grainy_on_el, is_form_grainy],
    [bt_form_blur_off_el, (!is_form_blur)],
    [bt_form_blur_on_el, is_form_blur],
    [bt_modif_lumin_off_el, (!is_step_lumin)],
    [bt_modif_lumin_on_el, is_step_lumin],
    [bt_step_double_off_el, (!is_step_double)],
    [bt_step_double_on_el, is_step_double]
  ];

  for (let one_el_idx = set_els.length-1; one_el_idx >= 0; one_el_idx--) {
    let one_el_info = set_els[one_el_idx];
    let one_el = one_el_info[0];
    let one_el_show = one_el_info[1];
    if (one_el) {
      if (one_el_show) {
        if (one_el.classList.contains(class_el_hidden)) {
          one_el.classList.remove(class_el_hidden);
        }
      } else {
        if (!(one_el.classList.contains(class_el_hidden))) {
          one_el.classList.add(class_el_hidden);
        }
      }
    }
  }
};

var make_current_slopes_outer = function (evt) {
  debug_output("make_current_slopes_outer");

  evt = evt || window.event;
  if (typeof evt !== "undefined") {
    if (evt.preventDefault) {evt.preventDefault();}
    if (evt.stopPropagation) {evt.stopPropagation();}
  }

  make_current_slopes(false);
};

var make_current_slopes = function (force) {
  debug_output("make_current_slopes");

  if ((!can_ori_ctx) || (!can_res_slopes_ctx)) {
    return;
  }

  set_slopes_knobs();
  update_filters();

  var do_eval = force;
  if (last_slopes_form != form_slopes) {
    do_eval = true;
  }
  if (last_slopes_lumin != lumin_slopes) {
    do_eval = true;
  }
  if (last_slopes_step != step_slopes) {
    do_eval = true;
  }

  if (do_eval) {
    slopes_highlight(can_ori_el, can_ori_ctx, can_res_slopes_ctx, can_width, can_height, form_slopes, lumin_slopes, step_slopes);
    last_slopes_step = step_slopes;
    last_slopes_lumin = lumin_slopes;
    last_slopes_form = form_slopes;
  }

  if (img_scaled) {
    update_scaled_view();
  }
};

////////////////////////////////////////////////////////////////////////
// using the ela part

var set_ela_computing = function (value) {
  debug_output("set_ela_computing");

  ela_inner_working = value;

  var class_computing = "ela-computing";
  let bt_modif_boosted_el = document.getElementById("bt-ela-modif-boosted");
  if (bt_modif_boosted_el) {
    if (value) {
      if (!(bt_modif_boosted_el.classList.contains(class_computing))) {
        bt_modif_boosted_el.classList.add(class_computing);
      }
    } else {
      if (bt_modif_boosted_el.classList.contains(class_computing)) {
        bt_modif_boosted_el.classList.remove(class_computing);
      }
    }
  }

};

var do_ela_finish = function () {
  debug_output("do_ela_finish");

  if (img_scaled) {
    update_scaled_view();
  }
  set_ela_computing(false);
};

var set_ela_display_knobs = function () {
  debug_output("set_ela_display_knobs");

  let bt_modif_boosted_off_el = document.getElementById("bt-ela-modif-boosted-off");
  let bt_modif_boosted_on_el = document.getElementById("bt-ela-modif-boosted-on");

  let set_els = [
    [bt_modif_boosted_off_el, (!boost_ela)],
    [bt_modif_boosted_on_el, boost_ela]
  ];

  for (let one_el_idx = set_els.length-1; one_el_idx >= 0; one_el_idx--) {
    let one_el_info = set_els[one_el_idx];
    let one_el = one_el_info[0];
    let one_el_show = one_el_info[1];
    if (one_el) {
      if (one_el_show) {
        if (one_el.classList.contains(class_el_hidden)) {
          one_el.classList.remove(class_el_hidden);
        }
      } else {
        if (!(one_el.classList.contains(class_el_hidden))) {
          one_el.classList.add(class_el_hidden);
        }
      }
    }
  }
};

var clean_ela_values = function () {
  debug_output("clean_ela_values");

  make_ela_last_set = 0.25;
  make_ela_last_used = -1;
  last_blur_ela = -1;
  last_boost_ela = "";
};

var set_ela_knobs = function () {
  debug_output("set_ela_knobs");

  if (ela_light_el) {
    ela_light_el.value = light_ela;
  }
  if (ela_blur_el) {
    ela_blur_el.value = blur_ela;
  }
};

var set_ela_display_blur = function () {
  debug_output("set_ela_display_blur");

  let ela_blur_val_el = document.getElementById("label-ela-blur-value");

  if (ela_blur_val_el) {
    let blur_str  = "" + blur_ela;
    if (blur_str.length == 3) {
      blur_str += "0";
    }
    ela_blur_val_el.innerHTML = blur_str;
  }
};

var set_ela_display_light = function () {
  debug_output("set_ela_display_light");

  let ela_light_val_el = document.getElementById("label-ela-light-value");

  if (ela_light_val_el) {
    ela_light_val_el.innerHTML = light_ela;
  }
};

var make_current_ela_outer = function (evt) {
  debug_output("make_current_ela_outer");

  evt = evt || window.event;
  if (typeof evt !== "undefined") {
    if (evt.preventDefault) {evt.preventDefault();}
    if (evt.stopPropagation) {evt.stopPropagation();}
  }

  make_current_ela(false);
};

var make_current_ela = function (force) {
  debug_output("make_current_ela");

  let curr_date = new Date();
  let curr_time = curr_date.getTime();
  if ((curr_time - make_ela_delay_set) > 1000) {
    make_ela_delay = 50;
  }
  make_ela_delay_set = curr_time;

  make_ela_last_set = blur_ela;

  if (make_ela_setup) {
    clearTimeout(make_ela_setup);
    make_ela_setup = null;
  }

  if ((!can_ori_ctx) || (!can_res_ela_ctx)) {
    return;
  }

  if (force) {
    make_current_ela_inner(force);
    return;
  }

  make_ela_setup = setTimeout(function () {
    make_ela_setup = null;
    make_current_ela_inner(false);
  }, make_ela_delay);

};

var make_current_ela_inner = function (force) {
  debug_output("make_current_ela_inner");

  if ((!can_ori_ctx) || (!can_res_ela_ctx)) {
    return;
  }

  var make_ela_last_set_now = ela_blur_el;
  if (make_ela_last_set_now < 0.01) {
    make_ela_last_set_now = 0.01;
  }
  if (make_ela_last_set_now > 0.99) {
    make_ela_last_set_now = 0.99;
  }

  if (make_ela_last_set != make_ela_last_set_now) {
    make_ela_last_set = make_ela_last_set_now;
    if (make_ela_setup) {
      clearTimeout(make_ela_setup);
      make_ela_setup = null;
    }
    if (!force) {
      make_ela_setup = setTimeout(function () {
        make_ela_setup = null;
        make_current_ela_inner();
      }, make_ela_delay);
      return;
    }
  }

  // should not start new job while waiting for the last one to get finished;
  if (ela_inner_working) {
    if (make_ela_setup) {
      clearTimeout(make_ela_setup);
      make_ela_setup = null;
    }
    make_ela_setup = setTimeout(function () {
      make_ela_setup = null;
      make_current_ela_inner();
    }, make_ela_delay);
    return;
  }

  if (make_ela_setup) {
    clearTimeout(make_ela_setup);
    make_ela_setup = null;
  }

  if ((last_blur_ela != blur_ela) || (last_boost_ela !== boost_ela)) {
    set_ela_computing(true);
    setTimeout(function () {
      eval_elav(can_ori_el, can_ori_ctx, can_res_ela_el, can_res_ela_ctx, can_width, can_height, blur_ela, boost_ela, do_ela_finish);
    }, 0);
    last_blur_ela = blur_ela;
    last_boost_ela = boost_ela;
  } else {
    if (img_scaled) {
      update_scaled_view();
    }
  }
};

////////////////////////////////////////////////////////////////////////
// using the pca part

var set_pca_display_knobs = function () {
  debug_output("set_pca_display_knobs");

  let bt_component_first_off_el = document.getElementById("bt-pca-component-first-off");
  let bt_component_first_on_el = document.getElementById("bt-pca-component-first-on");

  let bt_component_second_off_el = document.getElementById("bt-pca-component-second-off");
  let bt_component_second_on_el = document.getElementById("bt-pca-component-second-on");

  let bt_component_third_off_el = document.getElementById("bt-pca-component-third-off");
  let bt_component_third_on_el = document.getElementById("bt-pca-component-third-on");

  let bt_display_absolute_off_el = document.getElementById("bt-pca-display-absolute-off");
  let bt_display_absolute_on_el = document.getElementById("bt-pca-display-absolute-on");

  let bt_display_right_off_el = document.getElementById("bt-pca-display-right-off");
  let bt_display_right_on_el = document.getElementById("bt-pca-display-right-on");

  let bt_display_left_off_el = document.getElementById("bt-pca-display-left-off");
  let bt_display_left_on_el = document.getElementById("bt-pca-display-left-on");

  let show_component_first = false;
  let show_component_second = false;
  let show_component_third = false;

  let show_display_absolute = false;
  let show_display_right = false;
  let show_display_left = false;

  switch (pca_eigen_rank) {
    case 0:
      show_component_first = true;
      break;
    case 1:
      show_component_second = true;
      break;
    case 2:
      show_component_third = true;
      break;
    default:
      break;
  }

  switch (pca_eigen_mode) {
    case 0:
      show_display_absolute = true;
      break;
    case 1:
      show_display_right = true;
      break;
    case -1:
      show_display_left = true;
      break;
    default:
      break;
  }

  let set_els = [
    [bt_component_first_off_el, (!show_component_first)],
    [bt_component_first_on_el, show_component_first],
    [bt_component_second_off_el, (!show_component_second)],
    [bt_component_second_on_el, show_component_second],
    [bt_component_third_off_el, (!show_component_third)],
    [bt_component_third_on_el, show_component_third],
    [bt_display_absolute_off_el, (!show_display_absolute)],
    [bt_display_absolute_on_el, show_display_absolute],
    [bt_display_right_off_el, (!show_display_right)],
    [bt_display_right_on_el, show_display_right],
    [bt_display_left_off_el, (!show_display_left)],
    [bt_display_left_on_el, show_display_left]
  ];

  for (let one_el_idx = set_els.length-1; one_el_idx >= 0; one_el_idx--) {
    let one_el_info = set_els[one_el_idx];
    let one_el = one_el_info[0];
    let one_el_show = one_el_info[1];
    if (one_el) {
      if (one_el_show) {
        if (one_el.classList.contains(class_el_hidden)) {
          one_el.classList.remove(class_el_hidden);
        }
      } else {
        if (!(one_el.classList.contains(class_el_hidden))) {
          one_el.classList.add(class_el_hidden);
        }
      }
    }
  }
};

var clean_pca_values = function () {
  debug_output("clean_pca_values");

  pca_mean_values = null;
  pca_eigen_vectors = null;
  pca_eigen_rank_last = -1;
  pca_eigen_mode_last = "";
  pca_tried_onset = false;
  pca_failed = false;
};

var set_pca_knobs = function () {
  debug_output("set_pca_knobs");

  set_pca_knobs_light();
};

var set_pca_knobs_light = function () {
  debug_output("set_pca_knobs_light");

  if (pca_light_el) {
    pca_light_el.value = light_pca;
  }
};

var set_pca_display_light = function () {
  debug_output("set_pca_display_light");

  if (light_pca >= 0) {
    if (light_pca < 10) {
      light_pca_use = "1." + light_pca;
      light_pca_display = light_pca_use;
    } else if (light_pca == 10) {
      light_pca_use = "2.0";
      light_pca_display = light_pca_use;
    } else if (light_pca == 11) {
      light_pca_use = "2.5";
      light_pca_display = light_pca_use;
    } else if (light_pca == 12) {
      light_pca_use = "3.0";
      light_pca_display = light_pca_use;
    } else if (light_pca == 13) {
      light_pca_use = "3.5";
      light_pca_display = light_pca_use;
    } else if (light_pca == 14) {
      light_pca_use = "4.0";
      light_pca_display = light_pca_use;
    } else if (light_pca == 15) {
      light_pca_use = "4.5";
      light_pca_display = light_pca_use;
    } else if (light_pca <= 20) {
      light_pca_use = "" + (light_pca-11) + ".0";
      light_pca_display = light_pca_use;
    } else if (light_pca == 21) {
      light_pca_use = "10";
      light_pca_display = light_pca_use;
    } else if (light_pca == 22) {
      light_pca_use = "12";
      light_pca_display = light_pca_use;
    } else if (light_pca == 23) {
      light_pca_use = "15";
      light_pca_display = light_pca_use;
    } else {
      light_pca_use = "20";
      light_pca_display = light_pca_use;
    }
  } else {
    if (light_pca > -10) {
      light_pca_use = "0." + (10+light_pca);
      light_pca_display = light_pca_use;
    } else {
      light_pca_use = "0.1";
      light_pca_display = light_pca_use;
    }
  }

  let pca_light_val_el = document.getElementById("label-pca-light-value");

  if (pca_light_val_el) {
    pca_light_val_el.innerHTML = light_pca_display;
  }
};

var make_current_pca_outer = function (evt) {
  debug_output("make_current_pca_outer");

  evt = evt || window.event;
  if (typeof evt !== "undefined") {
    if (evt.preventDefault) {evt.preventDefault();}
    if (evt.stopPropagation) {evt.stopPropagation();}
  }

  make_current_pca(false);
};

var make_current_pca = function (force) {
  debug_output("make_current_pca");

  if (!can_ori_ctx) {
    return;
  }

  if (!pca_tried_onset) {
    let onset_res = pca_compute_principle_components(can_ori_ctx, can_width, can_height);
    pca_tried_onset = true;

    if ("mean_values" in onset_res) {
      pca_mean_values = onset_res["mean_values"];
    }
    if ("eigen_vectors" in onset_res) {
      pca_eigen_vectors = onset_res["eigen_vectors"];
    }
  }

  if ((!pca_mean_values) || (!pca_eigen_vectors)) {
    // has to show info on the issue;
    pca_failed = true;
    let pca_top_el = document.getElementById("bt-main-pca");
    if (pca_top_el) {
      if (!(pca_top_el.classList.contains(class_top_bt_disabled))) {
        pca_top_el.classList.add(class_top_bt_disabled);
      }
    }
    set_image_notice("can not show PCA for the image");
    show_image_notice(true);
    hide_image_notice(default_notice_timeout);
    return;
  }

  let to_eval = force;
  if ((pca_eigen_rank_last != pca_eigen_rank) || (pca_eigen_mode_last != pca_eigen_mode)) {
    to_eval = true;
  }

  if (to_eval) {
    let eigen_vector = pca_eigen_vectors[pca_eigen_rank];
    pca_fill_requested_projection(can_ori_ctx, can_res_pca_ctx, can_width, can_height, pca_mean_values, eigen_vector, pca_eigen_mode);

    if (pca_eigen_mode != 0) {
      histogram_equalize_gray(can_res_pca_ctx, can_res_pca_ctx, can_width, can_height);
    }

    pca_eigen_rank_last = pca_eigen_rank;
    pca_eigen_mode_last = pca_eigen_mode;
  }

  if (img_scaled) {
    update_scaled_view();
  }
};

////////////////////////////////////////////////////////////////////////
// css-wise setting

var update_filters_outer = function (evt) {
  debug_output("update_filters_outer");

  evt = evt || window.event;
  if (typeof evt !== "undefined") {
    if (evt.preventDefault) {evt.preventDefault();}
    if (evt.stopPropagation) {evt.stopPropagation();}
  }

  update_filters();
};

var update_filters = function () {
  debug_output("update_filters");

  if (main_part == "levels") {

    let filter_val = "";
    if (gray_levels_val) {
      filter_val += "grayscale(1) ";
    }
    filter_val += "brightness(" + (0.5/center_levels_val) + ")";
    if (contrast_levels_val > 0) {
      filter_val += " contrast(" + (1 + (contrast_levels_val/10)) +")";
    }

    if (can_res_levels_el) {
      can_res_levels_el.style.filter = filter_val;
    }
    if (can_res_scl_el) {
      can_res_scl_el.style.filter = filter_val;
    }

    return;
  }

  if (main_part == "pca") {
    let pca_lightness = "brightness(" + light_pca_use + ")";

    if (can_res_scl_el) {
      can_res_scl_el.style.filter = pca_lightness;
    }
    if (can_res_pca_el) {
      can_res_pca_el.style.filter = pca_lightness;
    }
    return;
  }

  if (main_part == "slopes") {

    let filter_val = "brightness(";
    if (lumin_slopes) {
      if (form_slopes=="blur") {
        filter_val += (light_slopes/6);
      } else {
        filter_val += (light_slopes/12);
      }
    } else {
      if (form_slopes=="blur") {
        filter_val += (light_slopes/2);
      } else {
        filter_val += (light_slopes/4);
      }
    }
    filter_val += ")";

    if (can_res_slopes_el) {
      can_res_slopes_el.style.filter = filter_val;
    }
    if (can_res_scl_el) {
      can_res_scl_el.style.filter = filter_val;
    }

    return;
  }

  if (main_part == "ela") {
    if (can_res_scl_el) {
      can_res_scl_el.style.filter = "brightness(" + light_ela + ")";
    }
    if (can_res_ela_el) {
      can_res_ela_el.style.filter = "brightness(" + light_ela + ")";
    }

    return;
  }
};

////////////////////////////////////////////////////////////////////////
// switching among the main views/parts

var main_use_part_outer = function (evt, use_part) {
  debug_output("main_use_part_outer");

  evt = evt || window.event;
  if (typeof evt !== "undefined") {
    if (evt.preventDefault) {evt.preventDefault();}
    if (evt.stopPropagation) {evt.stopPropagation();}
  }

  if (!image_is_loaded) {
    if (use_part in {"levels":true, "pca":true, "slopes":true, "ela":true}) {
      blink_load_button();
      return;
    }
  }

  main_use_part(use_part);
};

var main_use_part = function (use_part) {
  debug_output("main_use_part: " + use_part);

  main_part = use_part;
  update_filters();

  var var_class = "varies-within";
  var use_class = "within-" + use_part;

  var tags_varying = document.getElementsByClassName(var_class);
  var tags_varying_len = tags_varying.length;
  for (let ind = tags_varying_len - 1; ind>=0; ind--) {
    var cur_el = tags_varying[ind];
    if (!(cur_el.classList.contains(use_class))) {
      cur_el.style.display = "none";
    } else {
      cur_el.style.display = "block";
    }
  }

  var bt_class = "button-main-part";
  var bt_class_act = "button-main-part-active";
  var bt_id = "bt-main-" + use_part;

  var tags_main = document.getElementsByClassName(bt_class);
  var tags_main_len = tags_main.length;
  for (let ind = tags_main_len - 1; ind>=0; ind--) {
    var cur_el = tags_main[ind];
    if (cur_el.id != bt_id) {
      cur_el.classList.remove(bt_class_act);
    } else {
      cur_el.classList.add(bt_class_act);
    }
  }

  switch (use_part) {
    case "meta":
      make_current_meta(true);
      break;
    case "levels":
      make_current_levels(false);
      break;
    case "pca":
      make_current_pca(false);
      break;
    case "slopes":
      make_current_slopes(false);
      break;
    case "ela":
      make_current_ela(true);
      break;
    case "about":
      make_current_about(true);
      break;
    default:
      break;
  }

};

////////////////////////////////////////////////////////////////////////
// setting which image (original vs. analysis result) to show

var images_show_stage_outer = function (evt, stage_show) {
  debug_output("images_show_stage_outer");

  evt = evt || window.event;
  if (typeof evt !== "undefined") {
    if (evt.preventDefault) {evt.preventDefault();}
    if (evt.stopPropagation) {evt.stopPropagation();}
  }

  images_show_stage(stage_show);
};

var images_show_stage = function (stage_show) {
  debug_output("images_show_stage: " + stage_show);

  image_stage_shown = stage_show;

  var bt_show_ini = document.getElementById("bt-images-ini");
  var bt_show_mix = document.getElementById("bt-images-mix");
  var bt_show_fin = document.getElementById("bt-images-fin");
  var class_active = "bt-images-show";

  if (stage_show == "ini") {
    if (bt_show_ini) {
      if (!(bt_show_ini.classList.contains(class_active))) {
        bt_show_ini.classList.add(class_active);
      }
    }
    if (bt_show_mix) {
      if (bt_show_mix.classList.contains(class_active)) {
        bt_show_mix.classList.remove(class_active);
      }
    }
    if (bt_show_fin) {
      if (bt_show_fin.classList.contains(class_active)) {
        bt_show_fin.classList.remove(class_active);
      }
    }

    let orig_el = document.getElementById("field-orig-parts");
    let result_el = document.getElementById("field-result-parts");
    if (orig_el) {
      orig_el.style.display = "block";
    }
    if (result_el) {
      result_el.style.display = "none";
    }
  }
  if (stage_show == "mix") {
    if (bt_show_mix) {
      if (!(bt_show_mix.classList.contains(class_active))) {
        bt_show_mix.classList.add(class_active);
      }
    }
    if (bt_show_ini) {
      if (bt_show_ini.classList.contains(class_active)) {
        bt_show_ini.classList.remove(class_active);
      }
    }
    if (bt_show_fin) {
      if (bt_show_fin.classList.contains(class_active)) {
        bt_show_fin.classList.remove(class_active);
      }
    }

    let orig_el = document.getElementById("field-orig-parts");
    let result_el = document.getElementById("field-result-parts");
    if (orig_el) {
      orig_el.style.display = "block";
    }
    if (can_res_levels_el) {
      can_res_levels_el.style.opacity = "0.5";
    }
    if (can_res_pca_el) {
      can_res_pca_el.style.opacity = "0.5";
    }
    if (can_res_slopes_el) {
      can_res_slopes_el.style.opacity = "0.5";
    }
    if (can_res_ela_el) {
      can_res_ela_el.style.opacity = "0.5";
    }
    if (can_res_scl_el) {
      can_res_scl_el.style.opacity = "0.5";
    }
    if (result_el) {
      result_el.style.display = "block";
    }
  }
  if (stage_show == img_result_form) {
    if (bt_show_fin) {
      if (!(bt_show_fin.classList.contains(class_active))) {
        bt_show_fin.classList.add(class_active);
      }
    }
    if (bt_show_ini) {
      if (bt_show_ini.classList.contains(class_active)) {
        bt_show_ini.classList.remove(class_active);
      }
    }
    if (bt_show_mix) {
      if (bt_show_mix.classList.contains(class_active)) {
        bt_show_mix.classList.remove(class_active);
      }
    }

    let orig_el = document.getElementById("field-orig-parts");
    let result_el = document.getElementById("field-result-parts");
    if (orig_el) {
      orig_el.style.display = "none";
    }
    if (can_res_levels_el) {
      can_res_levels_el.style.opacity = "1.0";
    }
    if (can_res_pca_el) {
      can_res_pca_el.style.opacity = "1.0";
    }
    if (can_res_slopes_el) {
      can_res_slopes_el.style.opacity = "1.0";
    }
    if (can_res_ela_el) {
      can_res_ela_el.style.opacity = "1.0";
    }
    if (can_res_scl_el) {
      can_res_scl_el.style.opacity = "1.0";
    }
    if (result_el) {
      result_el.style.display = "block";
    }
  }

};

////////////////////////////////////////////////////////////////////////
// setting the scaled view

var images_change_scaled = function (evt) {
  debug_output("images_change_scaled");

  evt = evt || window.event;
  if (typeof evt !== "undefined") {
    if (evt.preventDefault) {evt.preventDefault();}
    if (evt.stopPropagation) {evt.stopPropagation();}
  }

  img_scaled = !img_scaled;
  images_set_scaled();
};

var images_set_scaled = function () {
  debug_output("images_set_scaled");

  let bt_on_el = document.getElementById("bt-scaled-on");
  let bt_off_el = document.getElementById("bt-scaled-off");

  if (img_scaled) {
    if (bt_on_el) {
      bt_on_el.style.display = "inline-block";
    }
    if (bt_off_el) {
      bt_off_el.style.display = "none";
    }
    if (can_ori_scl_el) {
      can_ori_scl_el.style.display = "block";
    }
    if (can_res_scl_el) {
      can_res_scl_el.style.display = "block";
    }
    if (can_ori_el) {
      can_ori_el.style.display = "none";
    }
    if (can_res_levels_el) {
      can_res_levels_el.style.display = "none";
    }
    if (can_res_pca_el) {
      can_res_pca_el.style.display = "none";
    }
    if (can_res_slopes_el) {
      can_res_slopes_el.style.display = "none";
    }
    if (can_res_ela_el) {
      can_res_ela_el.style.display = "none";
    }
    setTimeout(function () {
      can_ori_cvr_el.style.width = can_res_scl_el.width;
      can_ori_cvr_el.style.height = can_res_scl_el.height;
      can_res_cvr_el.style.width = can_res_scl_el.width;
      can_res_cvr_el.style.height = can_res_scl_el.height;
    }, 0);
  } else {
    if (bt_on_el) {
      bt_on_el.style.display = "none";
    }
    if (bt_off_el) {
      bt_off_el.style.display = "inline-block";
    }
    if (can_ori_scl_el) {
      can_ori_scl_el.style.display = "none";
    }
    if (can_res_scl_el) {
      can_res_scl_el.style.display = "none";
    }
    if (can_ori_el) {
      can_ori_el.style.display = "block";
    }
    if (can_res_levels_el) {
      can_res_levels_el.style.display = "block";
    }
    if (can_res_pca_el) {
      can_res_pca_el.style.display = "block";
    }
    if (can_res_slopes_el) {
      can_res_slopes_el.style.display = "block";
    }
    if (can_res_ela_el) {
      can_res_ela_el.style.display = "block";
    }
    can_ori_cvr_el.style.width = can_width;
    can_ori_cvr_el.style.height = can_height;
    can_res_cvr_el.style.width = can_width;
    can_res_cvr_el.style.height = can_height;
  }

  if (img_scaled) {
    update_scaled_view();
  }

};

////////////////////////////////////////////////////////////////////////
// the scaled view vs. page size changes

var update_scaled_view_outer = function (evt) {
  debug_output("update_scaled_view_outer");

  if (!img_scaled) {
    return;
  }
  if ((!can_ori_scl_el) || (!can_res_scl_el)) {
    return;
  }

  let curr_date = new Date();
  last_scale_update = curr_date.getTime();

  if (last_scale_awaits) {
    return;
  }
  last_scale_awaits = true;
  update_scaled_view_timer();

};

var update_scaled_view_timer = function () {
  debug_output("update_scaled_view_timer");

  let curr_date = new Date();
  var curr_time = curr_date.getTime();
  if ((curr_time - last_scale_update)>100) {
    last_scale_awaits = false;
    update_scaled_view();
    return;
  }

  setTimeout(function () {
     update_scaled_view_timer();
  }, 50);

};

var update_scaled_view = function () {
  debug_output("update_scaled_view");

  var cur_vis_size = get_field_size();
  var cur_width = cur_vis_size[0];
  var cur_height = cur_vis_size[1];
  if ((!cur_width) || (!cur_height)) {
    return;
  }

  last_scale_form = main_part;

  var cur_aspect = cur_width / cur_height;
  if (cur_aspect > img_aspect) {
    cur_width = Math.trunc(cur_height * img_aspect);
  }
  if (cur_aspect < img_aspect) {
    cur_height = Math.trunc(cur_width / img_aspect);
  }

  can_ori_scl_el.width = cur_width;
  can_ori_scl_el.height = cur_height;

  can_res_scl_el.width = cur_width;
  can_res_scl_el.height = cur_height;

  can_ori_cvr_el.style.width = cur_width;
  can_ori_cvr_el.style.height = cur_height;
  can_res_cvr_el.style.width = cur_width;
  can_res_cvr_el.style.height = cur_height;

  var can_ori_scl_ctx = can_ori_scl_el.getContext("2d");
  var can_res_scl_ctx = can_res_scl_el.getContext("2d");

  can_ori_scl_ctx.drawImage(can_ori_el, 0, 0, can_width, can_height, 0, 0, cur_width, cur_height);

  var use_res_el = null;
  if (main_part=="levels") {
    use_res_el = can_res_levels_el;
  }
  if (main_part=="pca") {
    use_res_el = can_res_pca_el;
  }
  if (main_part=="slopes") {
    use_res_el = can_res_slopes_el;
  }
  if (main_part=="ela") {
    use_res_el = can_res_ela_el;
  }

  if (use_res_el) {
    can_res_scl_ctx.drawImage(use_res_el, 0, 0, can_width, can_height, 0, 0, cur_width, cur_height);
  }

};

////////////////////////////////////////////////////////////////////////
// keys-based actions

var traverse_main_outer = function (evt, forwards) {
  debug_output("traverse_main_outer");

  evt = evt || window.event;
  if (typeof evt !== "undefined") {
    if (evt.preventDefault) {evt.preventDefault();}
    if (evt.stopPropagation) {evt.stopPropagation();}
  }

  traverse_main(forwards);
};

var traverse_main = function (forwards) {
  debug_output("traverse_main");

  switch (main_part) {
    case "levels":
      if (image_is_loaded) {
        if (forwards) {
          if (pca_failed) {
            main_use_part("slopes");
          } else {
            main_use_part("pca");
          }
        } else {
          main_use_part("meta");
        }
      }
      return;
    case "pca":
      if (image_is_loaded) {
        if (forwards) {
          main_use_part("slopes");
        } else {
          main_use_part("levels");
        }
      }
      return;
    case "slopes":
      if (image_is_loaded) {
        if (forwards) {
          main_use_part("ela");
        } else {
          if (pca_failed) {
            main_use_part("levels");
          } else {
            main_use_part("pca");
          }
        }
      }
      return;
    case "ela":
      if (image_is_loaded) {
        if (forwards) {
          main_use_part("about");
        } else {
          main_use_part("slopes");
        }
      }
      return;
    case "meta":
      if (image_is_loaded) {
        if (forwards) {
          main_use_part("levels");
        }
      } else {
        if (forwards) {
          main_use_part("about");
        }
      }
      return;
    case "about":
      if (image_is_loaded) {
        if (!forwards) {
          main_use_part("ela");
        }
      } else {
        if (!forwards) {
          main_use_part("meta");
        }
      }
      return;
    default:
      break;
  }
};

var traverse_local_outer = function (evt, forwards) {
  debug_output("traverse_local_outer");

  evt = evt || window.event;
  if (typeof evt !== "undefined") {
    if (evt.preventDefault) {evt.preventDefault();}
    if (evt.stopPropagation) {evt.stopPropagation();}
  }

  traverse_local(forwards);
};

var traverse_local = function (forwards) {
  debug_output("traverse_local");

  switch (main_part) {
    case "levels":
    case "pca":
    case "slopes":
    case "ela":
      if (forwards) {
        if (image_stage_shown == "mix") {
          images_show_stage(img_result_form);
          return;
        }
        if (image_stage_shown == "ini") {
          images_show_stage("mix");
          return;
        }
      } else {
        if (image_stage_shown == img_result_form) {
          images_show_stage("mix");
          return;
        }
        if (image_stage_shown == "mix") {
          images_show_stage("ini");
          return;
        }
      }
      return;
    case "meta":
      if (forwards) {
        if (disp_part_meta=="exif") {
          if (image_has_thumb) {
            disp_part_meta = "thumb";
          } else {
            disp_part_meta = "file";
          }
          make_current_meta(true);
          return;
        }
        if (disp_part_meta=="thumb") {
          disp_part_meta = "file";
          make_current_meta(true);
          return;
        }
      } else {
        if (disp_part_meta=="thumb") {
          if (image_has_exif) {
            disp_part_meta = "exif";
            make_current_meta(true);
          }
          return;
        }
        if (disp_part_meta=="file") {
          if (image_has_thumb) {
            disp_part_meta = "thumb";
            make_current_meta(true);
            return;
          }
          if (image_has_exif) {
            disp_part_meta = "exif";
            make_current_meta(true);
          }
          return;
        }
      }
      return;
    case "about":
      if (forwards) {
        if (disp_part_about == "forensics") {
          disp_part_about = "meta";
          make_current_about(true);
          return;
        }
        if (disp_part_about == "meta") {
          disp_part_about = "levels";
          make_current_about(true);
          return;
        }
        if (disp_part_about == "levels") {
          disp_part_about = "pca";
          make_current_about(true);
          return;
        }
        if (disp_part_about == "pca") {
          disp_part_about = "slopes";
          make_current_about(true);
          return;
        }
        if (disp_part_about == "slopes") {
          disp_part_about = "ela";
          make_current_about(true);
          return;
        }
        if (disp_part_about == "ela") {
          disp_part_about = "image";
          make_current_about(true);
          return;
        }
        return;
      } else {
        if (disp_part_about == "meta") {
          disp_part_about = "forensics";
          make_current_about(true);
          return;
        }
        if (disp_part_about == "levels") {
          disp_part_about = "meta";
          make_current_about(true);
          return;
        }
        if (disp_part_about == "pca") {
          disp_part_about = "levels";
          make_current_about(true);
          return;
        }
        if (disp_part_about == "slopes") {
          disp_part_about = "pca";
          make_current_about(true);
          return;
        }
        if (disp_part_about == "ela") {
          disp_part_about = "slopes";
          make_current_about(true);
          return;
        }
        if (disp_part_about == "image") {
          disp_part_about = "ela";
          make_current_about(true);
          return;
        }
        return;
      }
      return;
    default:
      break;
  }
};

